import { BlockchainCommonErrors, DomainName, EVMContractAddress } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { ContractOverrides, IERC7529Contract, WrappedTransactionResponse } from "../interfaces/index.js";
export declare abstract class ERC7529Contract<T> extends BaseContract<T> implements IERC7529Contract<T> {
    protected providerOrSigner: ethers.Provider | ethers.Signer;
    protected contractAddress: EVMContractAddress;
    constructor(providerOrSigner: ethers.Provider | ethers.Signer, contractAddress: EVMContractAddress, abi?: ethers.InterfaceAbi);
    addDomain(domain: DomainName, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | T>;
    removeDomain(domain: DomainName, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | T>;
    getDomains(): ResultAsync<DomainName[], BlockchainCommonErrors | T>;
}
//# sourceMappingURL=ERC7529Contract.d.ts.map