import { EVMAccountAddress, MinimalForwarderContractError, BigNumberString, Signature, BlockchainCommonErrors } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
import { IBaseContract } from "../interfaces/IBaseContract.js";
import { ContractOverrides, IMinimalForwarderRequest, WrappedTransactionResponse } from "../interfaces/objects";
export interface IMinimalForwarderContract extends IBaseContract {
    getNonce(from: EVMAccountAddress): ResultAsync<BigNumberString, MinimalForwarderContractError | BlockchainCommonErrors>;
    verify(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<boolean, MinimalForwarderContractError | BlockchainCommonErrors>;
    execute(request: IMinimalForwarderRequest, signature: Signature, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | MinimalForwarderContractError>;
}
export declare const IMinimalForwarderContractType: unique symbol;
//# sourceMappingURL=IMinimalForwarderContract.d.ts.map